function X = DCTIV(x)

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Efficient computation of DCT-IV coefficients         %
% Olivier Derrien - LMA/CNRS - 02.2015                 %
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

% Get signal length
N = length(x);

% Force x to be a line vector
if size(x,2) == 1
    x = x';
end

% Discrete time and/or frequency vector
tf = [0:N-1];

% DCT-IV computation using FFT
X = zeros(1, 2*N);
X(1:N) = x .* exp(-j*pi*tf/2/N);
X = fft(X);
X = X(1:N);
X = sqrt(2/N)*real(X .* exp(-j*pi*(tf+0.5)/2/N));
